function YAML_Form_Validator(form_id,data) {
  this.validate = function(obj,rules) {
    var result = false
    if (rules.val=='notempty' && obj.value=='') result='Это поле обязательно для заполнения';
	else if (rules.val=='email') {
	  re = new RegExp(/^[a-zA-Z0-9_\-\.]+@[a-zA-Z0-9\.\-]+$/);
	  if (!obj.value.match(/^[a-zA-Z0-9_\-\.]+@[a-zA-Z0-9\.\-]+$/)) result='Введите корректный адрес EMail';
	}
	else if (rules.val=='regexp' && rules.regexp) {
	  var re = new RegExp(rules.regexp);
	  if (!obj.value.match(re)) result = 'Введение значение, соответствующее регулярному выражению '+rules.regexp;
	}
	else if (rules.val=='int' || rules.val=='integer') {
	  var fint = parseInt(obj.value);
	  if (isNaN(fint)) result='Введенное значение не является целым числом';
	  if (rules.min && fint<parseInt(rules.min)) result='Значение не может быть меньше '+rules.min;
	  if (rules.max && fint>parseInt(rules.max)) result='Значение не может быть больше '+rules.max;
	}
	else if (rules.val=='float') {
	  var ffloat = parseFloat(obj.value);
	  if (!ffloat) result='Введенное значение не является числом';
	  if (rules.min && ffloat<parseInt(rules.min)) result='Значение не может быть меньше '+rules.min;
	  if (rules.max && ffloat>parseInt(rules.max)) result='Значение не может быть больше '+rules.max;
	}
	else if (rules.val=='tel' || rules.val=='phone') {
	  var fvalue = obj.value;
	  if (!fvalue.match(/^(\+\d+\s*)?\(?\d{3}\)?\s*\d{3}-?\d{2}-?\d{2}$/)) result='Введите корректный номер телефона в формате +N (NNN) NNN-NN-NN';
	}
	else if (rules.val=='url' && rules.proto) {
	  var proto_found=false;
	  var fvalue = obj.value;
	  for (i=0; i<rules.proto.length && !proto_found; i++) {
	    if (fvalue.indexOf(rules.proto[i]+'://')==0) proto_found=true;
	  }
	  if (!proto_found) result='Укажите корректный URL!';
	}
	else if (rules.val=='ip4' || rules.val=='ip') {
	  var fvalue = obj.value;
	  var ip_parts = fvalue.split('.');
	  var ip_found = (ip_parts.length==4);
	  for (i=0; i<4 && ip_found; i++) {
	    var curip=parseInt(ip_parts[i]);
		if (isNaN(curip) || curip<0 || curip>255) curip=false;
	  }
	  if (!curip) result='Укажите корректный IP-адрес';
	}
	else if (rules.val=='calendar') {
	  var dt = obj.value.match(/^(\d{1,2})\.(\d{1,2})\.(\d{4})( (\d{1,2}):(\d{1,2}))?$/);
	  if (!dt) {
	    result = 'Введите дату в формате ДД.ММ.ГГГГ';
	  }
	  else {
	    var month_len = [31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31];
	    dt[1]=parseInt(dt[1]);
	    dt[2]=parseInt(dt[2]);
    	dt[3]=parseInt(dt[3]);
		if (dt[2]<1 || dt[2]>12) result='Неправильно указан месяц!';
		if (dt[1]<1 || dt[1]>month_len[dt[2]-1]) result='Неправильно указан день!';
		if (dt[3]<0 || dt[3]>2100) result='Указан недопустимый год!';
		if (dt[1]==29 && dt[2]==2) {
		  if ((dt[3] % 4!=0) || ((dt[3] % 100)==0 && (dt[3] % 400)!=0)) result='Укаанный год не является високосным';
		}
		if (rules.time) {
		  dt[5]=parseInt(dt[5]);
		  dt[6]=parseInt(dt[6]);
		  if (!dt[4] || dt[5]<0 || dt[5]>=24 || dt[6]<0 || dt[6]>=60) result='Укажите время в формате ЧЧ:ММ, отделив его от даты пробелом';
		}
	  }
	}
	if (rules.maxlen && obj.value.length>rules.maxlen) result='Длина текста в этом поле не должна быть больше '+rules.maxlen+' символов';
	if (rules.callback) {
	 result=rules.callback(obj);
	}
	if (result!=false && rules.txt) result=rules.txt; // 
    return result;
  }
  this.fhandler = function(obj,rules,self) {
    var spans = obj.parentNode.getElementsByTagName('span');
	if (spans[1]) obj.parentNode.removeChild(spans[1]); // убираем элемент с сообщением об ошибке
    var error = self.validate(obj,rules);
    if (error) {
	  obj.className='err_item';
	  var err_elm = document.createElement('span');
	  err_elm.className = 'err_msg';
	  err_elm.innerHTML = error;
	  obj.parentNode.appendChild(err_elm);
	}
	else {
	  obj.className='ok_item';
	}
  }
  this.len_check=function(obj,maxlen) {
    return function() {
      var small = obj.parentNode.getElementsByTagName('small');
      if (small[0]) {
  	    if (obj.value.length<=maxlen) mlf.className = 'text_counter';
	    else mlf.className = 'text_overflow';
	    mlf.innerHTML = maxlen-obj.value.length;
	  }
	}
  }
  this.ftotal=function(data,self) {
    for (var key in data) {
      var fld = self.frm.elements[key];
      if (fld) { 
	    if (self.validate(fld,data[key])) return false; // если хоть одна валидация прошла неудачно
	  }
	}
	return true;	
  }
  this.listener = function(obj,rules,self) {
    return function() {
	   self.fhandler(obj,rules,self);
	}
  }
  this.bind = function(elm,event,handler) {
    if (elm.addEventListener) elm.addEventListener(event,handler,false);
	else if (elm.attachEvent) elm.attachEvent('on'+event,hanlder);
  }
  this.frm=document.getElementById(form_id);
  if (!this.frm) return false; // если форма не найдена, то выходим
  var self = this;
  for (var curfield in this.frm.elements) {
    var fld=this.frm.elements[curfield];
    if (data[fld.name]) { // если для этого поля есть описание валидации
	  this.bind(fld,'blur',this.listener(fld,data[fld.name],self));
	}
	else if ((fld.tagName=='INPUT' && fld.type!='submit' && fld.type!='checkbox' && fld.type!='radio') || 
	   fld.tagName=='TEXTAREA') this.bind(fld,'blur',listener(fld,{},self)); // если для поля нет правил, вешаем пустой обработчик, чтобы выделить поле как заполенное правильно
	if (fld.tagName=='TEXTAREA' && data[fld.name] && data[fld.name].maxlen) {
	  var mlf=document.createElement('small');
	  if (fld.value.length<=data[fld.name].maxlen) mlf.className = 'text_counter';
	  else mlf.className = 'text_overflow';
	  mlf.innerHTML = data[fld.name].maxlen-fld.value.length;
	  mlf.title='Количество оставшихся символов';
	  fld.parentNode.appendChild(mlf);
	  this.bind(fld,'keydown',this.len_check(fld,data[fld.name].maxlen));
	  this.bind(fld,'change',this.len_check(fld,data[fld.name].maxlen));
	}
  }
  this.bind(this.frm,'submit',function(evt) {
    var result=self.ftotal(data,self);
	if (!result) {
      if (evt.preventDefault) evt.preventDefault();
	  else evt.returnValue = false;
	}
    return result;
  },false);
}